/* Primfaktorzerlegung einer positiven natuerlichen Zahl n
 */
#include <stdlib.h>
#include <stdio.h>
#include <gmp.h>
void div_potenz(mpz_t*, mpz_t);
int main() {
   unsigned int i;
   mpz_t n,l,tmp;
   unsigned int r[3]={2,3,5}, q[8]={7,11,13,17,19,23,29,31};
   mpz_init(n);
   mpz_init(l);
   mpz_init(tmp);
   printf("\nBerechnung der Primfaktorzerlegung von n\n\n");
   printf("n = ");
   mpz_inp_str(n,stdin,10);
   if (mpz_cmp_ui(n,1)!=0) {
      printf("Die Primfaktoren von ");
      mpz_out_str(stdout,10,n);
      printf(" sind:\n\n");
      for (i=0; i<3; i=i+1) {
	 mpz_set_ui(tmp,r[i]);
	 div_potenz(&n,tmp);
      }
      do {
	 for (i=0; i<8;i=i+1) {
	    mpz_mul_ui(tmp,l,30);
	    mpz_add_ui(tmp,tmp,q[i]);
	    div_potenz(&n,tmp);
	 }
         mpz_add_ui(l,l,1);
	 mpz_mul_ui(tmp,l,30);
	 mpz_add_ui(tmp,tmp,7);
	 mpz_mul(tmp,tmp,tmp);
      } while (mpz_cmp(tmp,n)<=0);
      if (mpz_cmp_ui(n,1)>0) {
	 mpz_out_str(stdout,10,n);
	 printf(" Exp.: 1\n");
      }
   }
   mpz_clear(n);
   mpz_clear(l);
   mpz_clear(tmp);
   exit(EXIT_SUCCESS);
}
/* Pruefen, ob p|x, Bestimmen und Herausdividieren der 
 * groessten p-Potenz */
void div_potenz(mpz_t *x, mpz_t p) {
   unsigned int e=0;
   mpz_t tmp;
   mpz_init(tmp);
   mpz_mod(tmp,*x,p);
   while (mpz_cmp_ui(tmp,0)==0) {
      e=e+1;
      mpz_divexact(*x,*x,p);
      mpz_mod(tmp,*x,p);
   }
   if (e>0) {
      mpz_out_str(stdout,10,p);
      printf(" Exp.: %u\n",e);
   }
   mpz_clear(tmp);
}
