#include "routines.h"

double gen_fact(double n, unsigned int m) {
   double c;
   unsigned int i;
   c=1.0;
   for (i=0; i<m; i=i+1) { 
      c=c*(n-i);
   }
   return (c);
}

int pow_naiv(int x, int n) {
   int p,i;
   p=1;
   for (i=0; i<n; i=i+1) {
      p=p*x;
   }
   return (p);
}

int pow_quick_it(int x, int n) {
   int p,q;
   p=1;
   q=x;
   while (n>=1) {
      if (n%2==1) {
	 p=p*q;
      }
      n=n/2;
      q=q*q;
   }
   return (p);
}

int pow_quick_rec(int x, int n) {
   int p;
   if (n==0) {
      return (1);
   }
   if (n%2==1) {
      return (x*pow_quick_rec(x,n-1));
   }
   p=pow_quick_rec(x,n/2);
   return (p*p);
}

int fib_it(int n) {
   int i,f0,f1,f;
   f0=0; f1=1;
   switch (n) {
    case 0: return (f0);
    case 1: return (f1);
    default: 
      for (i=2; i<=n; i=i+1) {
         f=f0+f1;
         f0=f1;
         f1=f;
      }
      return (f);
   }
}

int fib_rec(int n) {
   switch(n) {
    case 0: return (0);
    case 1: return (1);
    default: return (fibonacci_rec(n-1)+fibonacci_rec(n-2));
   }
}

int fib_quick(int n) {
   int f0,f1,q0,q1,r;
   f0=1; f1=0;
   q0=0; q1=1;
   while (n>=1) {
      if (n%2==1) {
	 r=f0;
	 f0=r*q0+f1*q1;
	 f1=r*q1+f1*q0+f1*q1;
      }
      n=n/2;
      r=q0;
      q0=r*r+q1*q1;
      q1=2*r*q1+q1*q1;
   }
   return (f1);
}

int gcd(int a, int b) {
   int r0,r1,r;
   a=abs(a);
   b=abs(b);
   if (a==0) {
      return (b);
   }
   if (b==0) {
      return (a);
   }
   r0=a; r1=b;
   while (r1!=0) {
      r=r0;
      r0=r1;
      r1=r%r1;
   }
   return (r0);
}

rat_zahl rat_zahl_std(rat_zahl r) {
   int d;
   if (r.n==0) {
      printf("Nenner ist null.\n");
      exit(EXIT_FAILURE);
   }
   if (r.n<0) {
      r.z=-r.z; r.n=-r.n;
   }
   d=gcd(r.z,r.n);
   r.z=r.z/d;
   r.n=r.n/d;
   return (r);
}

rat_zahl rat_zahl_add(rat_zahl r, rat_zahl s) {      
   rat_zahl t;
   t.z=r.z*s.n+s.z*r.n;
   t.n=r.n*s.n;
   return (rat_zahl_std(t));
}

rat_zahl rat_zahl_mul(rat_zahl r, rat_zahl s) {
   rat_zahl t;
   t.z=r.z*s.z;
   t.n=r.n*s.n;
   return (rat_zahl_std(t));
}
